
default:
  tags:
    - "docker"

variables:
  IMAGE_TAG: $CI_COMMIT_BRANCH-$CI_COMMIT_SHORT_SHA

stages:          # List of stages for jobs, and their order of execution
  - stop pipeline
  - some job
  - build
  - test
  - deploy
  - stop

image: busybox:latest

pipe_stop:
  stage: stop pipeline
  image: everpeace/curl-jq
  script:
    - |
      RUNNING_PIPLINES=$(curl -s -H "PRIVATE-TOKEN: $RUNNER_TOKEN" "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/pipelines?ref=${CI_COMMIT_REF_NAME}&status=running" | jq '.[] | .id' |tail -n +2 )
            for pipeline in ${RUNNING_PIPLINES}; \
                do echo "stopped ${pipeline}" && curl -s --request POST -H "PRIVATE-TOKEN: $RUNNER_TOKEN" "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/pipelines/${pipeline}/cancel"; done

sleep:
  stage: some job
  script:
    sleep 900

docker_build:
  image: docker:latest
  stage: build
  services:
    - docker:dind
  script:
    - docker login -u $GITLAB_CI_USER -p $GITLAB_CI_PASSWORD $CI_REGISTRY
    - echo $GITLAB_CI_USER $GITLAB_CI_PASSWORD $CI_REGISTRY $CI_REGISTRY_IMAGE:$IMAGE_TAG
    - docker build -t $CI_REGISTRY_IMAGE:$IMAGE_TAG .
    - docker push $CI_REGISTRY_IMAGE:$IMAGE_TAG

test-job:   # This job runs in the test stage.
  image: docker:latest
  stage: test    # It only starts when the job in the build stage completes successfully.
  services:
    - docker:dind
  script:
    - docker login -u $GITLAB_CI_USER -p $GITLAB_CI_PASSWORD $CI_REGISTRY
    - docker run $CI_REGISTRY_IMAGE:$IMAGE_TAG /bin/sh -c 'cat test.txt'

include:
    project: learn7612441/another
    file: .gitlab-ci.yml
    

deploy to preprod:
  stage: deploy
  variables:
    MyPassword: preprod
  script:
    - echo "My login is ${MyLogin}"
    - echo "My pass is ${MyPassword}"
  only:
    - main
  environment:
    name: preprod
    on_stop: stop to preprod
    auto_stop_in: 1 day

stop to preprod:
  stage: stop
  script:
    - echo "stop pipeline"
  rules:
    - if: $CI_COMMIT_REF_NAME == "main"
  environment:
    name: preprod
    action: stop

deploy to production:
  stage: deploy
  variables:
    MyPassword: production
  script:
    - echo "My login is ${MyLogin}"
    - echo "My pass is ${MyPassword}"
  only:
    - main
  when: manual
  environment:
    name: production

pages:
  stage: deploy
  script:
    - mkdir -p public
    - echo "Hello world" > public/index.html
  artifacts:
    paths:
      - public
  only:
    - main
